# FairMQ: fair::mq::shmem Namespace Reference

fair::mq::shmem Namespace Reference

## Classes

struct | BufferDebugInfo
struct | DeviceCounter
struct | EventCounter
class | Manager
class | Message
struct | MetaHeader
class | Monitor
class | Poller
struct | Region
struct | RegionBlock
struct | RegionCounter
struct | RegionInfo
struct | SegmentAddress
struct | SegmentAddressFromHandle
struct | SegmentAllocate
struct | SegmentAllocateAligned
struct | SegmentBufferShrink
struct | SegmentDeallocate
struct | SegmentFreeMemory
struct | SegmentHandleFromAddress
struct | SegmentInfo
struct | SegmentMemoryZeroer
struct | SegmentSize
struct | SessionId
struct | SharedMemoryError
struct | ShmId
class | Socket
struct | TerminalConfig
class | TransportFactory
class | UnmanagedRegion
struct | ZMsg

## Typedefs

using | SimpleSeqFitSegment = boost::interprocess::basic_managed_shared_memory< char, boost::interprocess::simple_seq_fit< boost::interprocess::mutex_family >, boost::interprocess::null_index >
using | RBTreeBestFitSegment = boost::interprocess::basic_managed_shared_memory< char, boost::interprocess::rbtree_best_fit< boost::interprocess::mutex_family >, boost::interprocess::null_index >
using | SegmentManager = boost::interprocess::managed_shared_memory::segment_manager
using | VoidAlloc = boost::interprocess::allocator< void, SegmentManager >
using | CharAlloc = boost::interprocess::allocator< char, SegmentManager >
using | Str = boost::interprocess::basic_string< char, std::char_traits< char >, CharAlloc >
using | StrAlloc = boost::interprocess::allocator< Str, SegmentManager >
using | StrVector = boost::interprocess::vector< Str, StrAlloc >
using | Uint16RegionInfoPairAlloc = boost::interprocess::allocator< std::pair< const uint16_t, RegionInfo >, SegmentManager >
using | Uint16RegionInfoMap = boost::interprocess::map< uint16_t, RegionInfo, std::less< uint16_t >, Uint16RegionInfoPairAlloc >
using | Uint16RegionInfoHashMap = boost::unordered_map< uint16_t, RegionInfo, boost::hash< uint16_t >, std::equal_to< uint16_t >, Uint16RegionInfoPairAlloc >
using | Uint16SegmentInfoPairAlloc = boost::interprocess::allocator< std::pair< const uint16_t, SegmentInfo >, SegmentManager >
using | Uint16SegmentInfoHashMap = boost::unordered_map< uint16_t, SegmentInfo, boost::hash< uint16_t >, std::equal_to< uint16_t >, Uint16SegmentInfoPairAlloc >

## Enumerations

enum | AllocationAlgorithm : int { rbtree_best_fit, simple_seq_fit }

## Functions

std::string | makeShmIdStr (const std::string &sessionId)
uint64_t | makeShmIdUint64 (const std::string &sessionId)
void | signalHandler (int signal)
std::pair< std::string, bool > | RunRemoval (std::function< bool(const std::string &)> f, std::string name, bool verbose)

## Detailed Description

Manager.h

Since
  2016-04-08

Author
  A. Rybalchenko

Region.h

Since
  2016-04-08

Author
  A. Rybalchenko

privacy